/**
 * A class providing vehicle functionality at different
 * smartness levels
   * Smart levels are:
   *   0 - random turns, no restrictions
   *   1 - avoid U-turns
   *   2 - greedy path to destination
   *   3 - A* search for a path
   *   4 - optimal search for a path
 * @authors Matthew C. Golob & Victor Jaworski
 */
 
import java.awt.*;

public class Ambulance1 extends Vehicle {

  private double length1;
  private Coord lastBack;
  private boolean setBack;
  private boolean t;
  private int count;

   
  public Ambulance1( String mk, String md, int l, int l1, int cars, int x, int y ) {

    super( mk, md, l, new Point(x, y), 1 );
    length1 = Global.SIZE_SCALE * l1 / Global.SCALE;
    setBack = false;
	 System.out.println("Ambulance 1");
  }	
   
  public void update(double distance) {
		super.update( distance * 2.5);
		count++;
		if (count%4==0){
		t=!t;
		}
  }
	
  /**
   * draw an Ambulance
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
	
    Coord back = where.diff( heading.scale(0.4*length) );
    Coord dir = lastBack.diff(back).normalize();
    Coord tback = back.sum(dir.scale(length1*.45));
    Coord whereS = where.screenScale();
    Coord backS = back.screenScale();
    Coord tbackS = tback.screenScale();
    /*
    Global.debug.println("Ambulance ID: " + ID + "; where  = " + where);
    Global.debug.println(" - Cargo length  = " + length1);
    Global.debug.println(" - back of cab  = " + back);
    Global.debug.println(" - last back of cargo  = " + lastBack);
    Global.debug.println(" - direction to back of cargo  = " + dir);
    Global.debug.println(" - back of cargo  = " + tback);
    */

    if ( t ) {
        g.setColor( Color.red );
        g.drawLine( (int) whereS.x, (int) whereS.y, 
		(int) backS.x, (int) backS.y );
        } else {
        g.setColor( Color.blue );
        g.drawLine( (int) whereS.x, (int) whereS.y, 
		(int) backS.x, (int) backS.y );
		}
    g.setColor( Color.white );
    g.drawLine( (int) backS.x, (int) backS.y, 
		(int) tbackS.x, (int) tbackS.y );
    lastBack = tback;
    }
	
  public void locate( Coord p, Coord h) {
    super.locate(p, h);
    if( !setBack ) {
      setBack = true;
      lastBack = where.diff( h.scale(length1) );
    }
  }

public Coord shuffle(Coord back, double speed, Coord dir) {
    Coord cabBack = super.shuffle( back, speed, dir );
    Coord newBack = cabBack.sum( dir.scale(length1) );
    if( Global.DEBUG ) {
      Global.debug.println( "; cargo back is now " + newBack );
    }
    return newBack;
  }

  public String toString() {
    return "Ambulance " + super.toString();
  }
}