/**
 * Collaboration statement:
 * The following students contributed to this project:
 * Jarret Lafleur    gtg416i   Code for the Bus Classes and Segway.
 * Jeremiah Tootle   gtg278h   Implementation Ideas, Code to fix traffic flow problems.
 * 
 * Assignment J4, COE 1361-B, April 20, 2003
 */


/**
 * A class simulating a bus
 */

import java.awt.*;
import javax.swing.*;

public class Bus extends Vehicle {

  int capacity;
  public int buscounter=1;//counter of how long the bus has been active
  public int countdown=200;//time the bus stops to offload/load passengers
  public JLabel directions;//A bunch of labels necessary for the tracking window
  public JLabel direct2;
  public JLabel head1;
  public JLabel head2;
  public JLabel speed2;
  public JLabel passengers1;
  public JLabel passengers2;
  public JLabel countdown1;
  public JLabel countdown2;
  public JLabel speedy1;
  public JLabel distance1;
  public JLabel distance2;
  public JLabel google;
  public JLabel thething;
  JFrame frame;
  double onboardfactor= (Math.random()); //A bunch of variables to determine passenger offload/onload
  int onboard;
  int randomoff;
  int randomon;
  int offmod;
  int onmod;
  public Coord prevpos; //Previous position
  public double totaldistance=0; //Mileage Counters
  public int runningtallydist;
  ImageIcon drivingico= new ImageIcon("AG00054_.gif"); //Load "Status Bar" GIFs
  Image DrivingImage = drivingico.getImage().getScaledInstance(70,8,Image.SCALE_DEFAULT);
  ImageIcon drivingicon=new ImageIcon(DrivingImage);
  ImageIcon stopico=new ImageIcon("AG00047_.gif");
  Image StoppedImage=stopico.getImage().getScaledInstance(70,8,Image.SCALE_DEFAULT);
  ImageIcon stopicon= new ImageIcon(StoppedImage);


  /**
   * Construct a new bus
   * @param mk the make of the bus
   * @param md the model of the bus
   * @param l its length in feet
   * @param people its passenger capacity (number of people it holds)
   * @param x its x location (map coordinates)
   * @param y its y location (map coordinates)
   */
  public Bus( String mk, String md, int l, int people, int x, int y) {

    super( mk, md, l, new Point(x, y), 1 );
    capacity= people;
	 System.out.println("Bus");
	 	 ImageIcon busicon= new ImageIcon("thebus.JPG"); //load the bus icon
	 	 Image BusImage = busicon.getImage();

		 frame = new JFrame("Bus "+ID); //Create the new frame.
		 frame.setSize(200,200);
		 frame.getContentPane().setBackground(Color.yellow);
		 frame.getContentPane().setLayout(new GridLayout(8,2));
		 
		 directions=new JLabel("Bus "+ID);
		 directions.setFont(new Font("TimesRoman 12 point bold.",Font.BOLD,20));
		 frame.getContentPane().add(directions);
		 
		 direct2=new JLabel(busicon,JLabel.LEFT);
		 frame.getContentPane().add(direct2);
		 
		 frame.getContentPane().add(new JLabel(""));
		 frame.getContentPane().add(new JLabel(""));
		 
		 head1=new JLabel("Heading");
		 head1.setFont(new Font("",Font.ITALIC,12));
		 frame.getContentPane().add(head1);
		 
		 head2=new JLabel(heading.toString());
		 frame.getContentPane().add(head2);
		 
		 thething=new JLabel(drivingicon,JLabel.LEFT);
		 frame.getContentPane().add(thething);
		 
		 speed2=new JLabel("");
		 frame.getContentPane().add(speed2);
		 
		 google=new JLabel("Speed");
		 google.setFont(new Font("",Font.ITALIC,12));
		 frame.getContentPane().add(google);
		 
		 speedy1=new JLabel("mph");
		 frame.getContentPane().add(speedy1);
		 
		 distance1=new JLabel("Mileage");
		 distance1.setFont(new Font("",Font.ITALIC,12));
		 frame.getContentPane().add(distance1);
		 
		 distance2=new JLabel("miles");
		 frame.getContentPane().add(distance2);
		 
		 passengers1=new JLabel("Passengers");
		 passengers1.setFont(new Font("",Font.ITALIC,12));
		 frame.getContentPane().add(passengers1);
		 
		 onboard=(int)(onboardfactor*capacity);
		 passengers2=new JLabel(onboard+"/"+capacity);
		 frame.getContentPane().add(passengers2);
		 
		 countdown1=new JLabel("Countdown");
		 countdown1.setFont(new Font("",Font.ITALIC,12));
		 frame.getContentPane().add(countdown1);
		 
		 countdown2=new JLabel(""+buscounter);
		 frame.getContentPane().add(countdown2);
		 
	 	 frame.setVisible(true); //Make everything visible
  }

  /**
   * draw a Bus
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
	g.setColor(Color.red);
	Coord corner= where.screenScale();
	g.drawOval((int)corner.x-10,(int)corner.y-10,20,20);
	g.drawString(""+ID,(int)corner.x-10,(int)corner.y-10);
  	if(stopped & countdown%3==0){ //If the bus is stopped, every third count make if flash red.
	    super.draw(g, Color.red);
	 }
 	else{ //Otherwise, just draw it yellow
 		super.draw(g, Color.yellow);
  	}
  }

  /**
   * update a Bus
   * @param distance distance to travel
   */
public void update(double distance) {
	prevpos=where; //Store where it is before it updates.
	randomoff=(int)(capacity*Math.random()); //Calculate random numbers of people to get off and on.
	randomon=(int)(capacity*Math.random());
	offmod=(int)(.5*200/randomoff); //Figure out the modulus to use in later calculations
	onmod=(int)(.5*200/randomon);
	boolean onhighway=(heading.distance(new Coord(1.0,0.0))>.1 & heading.distance(new Coord(-1.0,0.0))>.1 & heading.distance(new Coord(0.0,1.0))>.1  & heading.distance(new Coord(0.0,-1.0))>.1);//Is the bus on the highway (based on heading)?
	if (buscounter%1000==0 & !onhighway){ //If the bus isn't on the highway and is at 1000 ticks since its last stop
		stopped=true; //The bus is stopped.
			thething.setIcon(stopicon);
			countdown2.setText(""+countdown);
		countdown=countdown-1;//Increment the countdown.
		if (buscounter%offmod==0 & onboard>0){ //If it's time, bring someone onboard.
		    onboard=onboard-1;
		}
	    if (buscounter%onmod==0 & onboard<capacity){//If it's time, kick someone off the bus.
   		    	onboard=onboard+1;
	    }
	  	if (countdown<=0){ //If the countdown's done, get going again.
			buscounter=buscounter+1; //Restart the buscounter so it's no longer a multiple of 1000.
			countdown=200;
				thething.setIcon(drivingicon);
		}
			speed2.setText("Bus Stop");
			speedy1.setText(0+" mph");
	}
	else{ //If the bus is going
		buscounter=buscounter+1; //Increment the counter
		locate( where.sum( heading.scale(distance*.7) ), heading );
	    stopped = false;
		    speed2.setText("Driving");
	    int thespeed=(int)(where.distance(prevpos)*Global.SPEED_FACTOR); //Figure out the speed based on the difference between current and previous positions.
		    speedy1.setText(thespeed+" mph");
		    countdown2.setText(""+(((((int)(buscounter/1000)+1)*1000)-buscounter)));
	    totaldistance=(double)(totaldistance+(( thespeed)*Global.SIZE_SCALE/Global.SPEED_FACTOR));
	    runningtallydist=(int)Math.round(totaldistance); //Calculate the mileage.
		    distance2.setText(runningtallydist+" miles");
	 }
	 //Below, figure out what direction the bus is headed in and display it if the bus is being tracked.
	 if (heading.x>.95 & heading.x<1.05 & heading.distance(new Coord(1,0))<.1){
	 	head2.setText("East");
	 }
	 else if (heading.y>.95 & heading.y<1.05 & heading.distance(new Coord(0,1))<.1){
	 	head2.setText("South");
	 }
	 else if (heading.x<-.95 & heading.x>-1.05 & heading.distance(new Coord(-1,0))<.1){
	 	head2.setText("West");
	 }
	 else if (heading.y<-.95 & heading.y>-1.05 & heading.distance(new Coord(0,-1))<.1){
	 	head2.setText("North");
	 }
	 else if (heading.y>0){
	 	head2.setText("South on I-42");
	 }
	 else if (heading.y<0){
	 	head2.setText("North on I-42");
	 }
	 else { //This situation should never be fulfilled, but it provides a method for displaying the heading in case.
			head2.setText(heading.toString());
	 }
		passengers2.setText(onboard+"/"+capacity);
  }


  public String toString() {//Define a toString method.
    return "Bus " + super.toString();
  	}
}