/**
 * A class simulating a car
 * @author David M. Smith
 */
 
import java.awt.*;

public class Car extends Vehicle {

  double trunk;

  /**
   * Construct a new car
   * @param mk the make of the car
   * @param md the model of the car
   * @param l its length in feet
   * @param tr its trunk capacity in cubic feet
   * @param x its x location (map coordinates)
   * @param y its y location (map coordinates)
   */
  public Car( String mk, String md, int l, double tr, int x, int y ) {

    super( mk, md, l, new Point(x, y) );
    trunk = tr;
  }


  /**
   * draw a Car
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
    super.draw(g, Color.blue );
  }




  public String toString() {
    return "Car " + super.toString();
  }
}
