/**
 * A class simulating a motorcycle
 * @author David M. Smith
 */
 
import java.awt.*;

public class Cycle extends Vehicle {

    /**
     * Construct a new cycle
     * @param mk the make of the cycle
     * @param md the model of the cycle
     * @param l its length in feet
     * @param x its x location (map coordinates)
     * @param y its y location (map coordinates)
     */
	public Cycle( String mk, String md, int l, int x, int y ) {

		super( mk, md, l, new Point(x, y) );
	}


/**
 * update method moving the cycle
 * @param distance the distance in map coordinates
 */
 	public void update(double distance) {
		super.update( distance * 2.);
	}



	/**
	 * draw a Cycle
	 * @param g the graphics environment
	 */
	 public void draw(Graphics g) {
	 	super.draw(g, Color.red );
	 }



    /**
     * display the cycle
     */
	  public String toString() {
			return "Cycle " + super.toString();
	  }
}
