/**
 * A class simulating a car
 * @author David M. Smith
 */
 
import java.awt.*;

public class Firetruck extends Vehicle {

  double tail;

  /**
   * Construct a new car
   * @param mk the make of the car
   * @param md the model of the car
   * @param l its length in feet
   * @param tr its tail size in cubic feet
   * @param x its x location (map coordinates)
   * @param y its y location (map coordinates)
   */
  public Firetruck( String mk, String md, int l, double tr, int x, int y ) {

    super( mk, md, l, new Point(x, y) );
    tail = tr;
    System.out.println("FD-ATL Firetruck!");
  }


  /**
   * Draw the firetruck
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
    super.draw(g, Color.red );
    Coord front = where.screenScale();
	Coord rear = where.diff( heading.scale(0.75*length) ).screenScale();
    g.setColor(Color.yellow);
    g.drawLine( (int) front.x, (int) front.y, (int) rear.x, (int) rear.y );
  }

  public String toString() {
    return "Firetruck " + super.toString();
  }
}
