/**
 * A class simulating a car
 * @author David M. Smith
 */

import java.awt.*;

public class Limo extends Vehicle {

  int maxpassengers;

  /**
   * Construct a new car
   * @param mk the make of the car
   * @param md the model of the car
   * @param l its length in feet
   * @param maxp is the maximum number of passengers allowed in the Limo.
   * @param x its x location (map coordinates)
   * @param y its y location (map coordinates)
   */
  public Limo( String mk, String md, int l, int maxp, int x, int y ) {

    super( mk, md, l, new Point(x, y) );
    this.maxpassengers = maxp;
	 System.out.println("Limo");
  }


  /**
   * draw a Car
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
    super.draw(g, Color.pink );
	Coord back = where.diff( heading.scale(0.75*length) ).screenScale();
	 Coord front = where.screenScale();

	 g.setColor(Color.pink);
	 g.fillRect( (int) front.x, (int) front.y, 6, 4);
  }
  
  
  public void update(double distance) {
	  super.update( distance / 4.);
  }



  public String toString() {
    return "Limo " + super.toString();
  }
}
