public class LinkedLst {
	private ListNode head;

	public LinkedLst() {
		head = null;
	}

	public int count() {
	 	return countHelper(head);
	}

	private int countHelper(ListNode curr) {
	 	if( curr == null ) return 0;
		else return 1 + countHelper(curr.next);
	}

	public int sum() {
	 	return sumHelper(head);
	}

	private int sumHelper(ListNode curr) {
	 	if( curr == null ) return 0;
		else return ((Integer)curr.data).intValue() 
		                    + sumHelper(curr.next);
	}

	public void addToHead( Object d ) {
   	head = new ListNode( d, head );
	}

	public void addToTailIterative( Object d ) { 
		ListNode current = head; 

		if( current == null ) {
		 	head = new ListNode( d, null );
		} else {
			while( current.next != null ) {
			 	current = current.next;
			}
			current.next = new ListNode(d, null);
		}
	};
	
	public void addToTailRecursive( Object d ) { 

		head = addHelper(head, d);
	};

	private ListNode addHelper(ListNode n, Object d) {
	 	if( n == null ) return new ListNode(d, null);
		else {
			n.next = addHelper(n.next, d);
			return n;
		}
	}
	
	public void insertInOrder( Comparable d ) { 
		head = insertHelper(head, d);
	};

	private ListNode insertHelper(ListNode n, Comparable d) {
		if( n == null ) return new ListNode( d, null );
		else if( d.compareTo(n.data) < 0 ) return new ListNode( d, n );
		else {
			n.next = insertHelper( n.next, d );
			return n;
		}
	}
	
	public String toString() {
	 	String res = "Linked List:";
		int count = 0;

		ListNode current = head;
		while( current != null ) {
			if( (count % 10) == 0 ) res = res + "\n";
			                 else res = res + "; ";
		 	res = res + current.data;
			current = current.next;
			count++;
		}
		return res;
	}

	public static void main(String[] args) {
		LinkedLst l = new LinkedLst();
		int i;
		int value;

		for( i = 0; i < 10; i++ ) {
		 	l.addToTailIterative( new Integer (i) );
			System.out.println( "Add to Tail Iteration " + i + ": " + l );
		}
		for( i = 10; i < 20; i++ ) {
		 	l.addToHead( new Integer (i) );
			System.out.println("Add to Head Iteration " + i + ": " + l );
		}
		for( i = 20; i < 30; i++ ) {
		 	l.addToTailRecursive( new Integer (i) );
			System.out.println("Add to Tail R Iteration " + i + ": " + l );
		}

		LinkedLst s = new LinkedLst();

		for( i = 0; i < 30; i++ ) {
		 	 value = (int) (1000 * Math.random());
			 s.insertInOrder(new Integer(value));
			System.out.println("Insert " + value + ": " + s );
		}
		System.out.println("count " + s.count() + "; sum " + s.sum());
	}
}


