/**
 * A class providing the storage for the traffic map
 * @author David M. Smith
 */
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import java.io.*;


public class Map extends JPanel implements Runnable{
  int iteration;
  public boolean isRunning = true;
  public static boolean LargeModel;

  //------------------------------------------------------------------
  //
  /**
   *   basic constructor
   *   <BR><BR>
   * @param d the screen size
   */
  public Map( Dimension d, boolean isLarge ) {

    LargeModel = isLarge;

    if( LargeModel ) {
      Global.SCALE = 8; //10;   
      Global.X_OFFSET = 370; // 480 
      Global.Y_OFFSET = 160; // 200; ; 
      Global.STREET_WIDTH = 4; 
      Global.AT_FRONT = 1.1; // 0.85; 
    } else {
      Global.SCALE =  26; // 30; 
      Global.X_OFFSET = 1200; // 1500; 
      Global.Y_OFFSET = 56; // 70; 
      Global.STREET_WIDTH = 8; 
      Global.AT_FRONT = 0.69;

    }
    Global.screenSize = new Coord( d.width, d.height );
    iteration = 0;
    initStreets();
    initIntersections();
  }


  /**
   *   stop the animation.
   *   <BR><BR>
   */
  public void stop() {
    if( Global.DEBUG ) Global.debug.println("STOP");
    isRunning = false; 
  }
    
    
  /**
   *   repaint the display
   */
  final Color backColor = new Color( 200, 200, 255 );
    
  public void paintComponent(Graphics g) {

    Dimension d;

    g.setColor(backColor);
    d = getSize();
    g.fillRect(0, 0, d.width, d.height);
    Global.streets.draw(g);
    Global.intersections.draw(g);
    g.setColor(Color.black);
    g.drawString( (Vehicle.getTotal()-1) + " Vehicles", 20, 20 );
  } 
   

  public void run() {
    do {
      //			if( Global.DEBUG)
      //				Global.debug.println("Update intersections");
      Global.intersections.update(Global.dt);
      if( (iteration % (20000/Global.DELAY)) == 0 ) {
	//				if( Global.DEBUG)
	//					Global.debug.println("add vehicles");
			addVehicles();
      }
      iteration++;
      //			if( Global.DEBUG)
      //				Global.debug.println("Update streets");
      Global.streets.update(Global.dt);
      repaint();
      try{
	Thread.sleep(Global.DELAY);
      } catch (InterruptedException e) {}

    } while (isRunning);
  }
  private static int Second_1 = 0;
  private static int Second_2 = 1;
  private static int A_1 = 2;
  private static int A_2 = 3;
  private static int First_1 = 4;
  private static int First_2 = 5;
  private static int First_3 = 6;
  private static int First_4 = 7;
  private static int First_5 = 8;
  private static int First_6 = 9;
  private static int First_7 = 10;
  private static int Second_3 = 11;
  private static int Second_4 = 12;
  private static int Second_5 = 13;
  private static int Second_6 = 14;
  private static int Second_7 = 15;
  private static int Third_1 = 16;
  private static int Third_2 = 17;
  private static int Third_3 = 18;
  private static int Third_4 = 19;
  private static int Third_5 = 20;
  private static int Third_6 = 21;
  private static int Third_7 = 22;
  private static int Third_8 = 23;
  private static int Fourth_1 = 24;
  private static int Fourth_2 = 25;
//  private static int Fourth_3 = 26;
  private static int DirtRoad_1 = 26;     //Fourth_3 is now the dirt road. = only for FourByFourTruck.
  private static int Fourth_4 = 27;
  private static int Fourth_5 = 28;
  private static int A_3 = 29;
  private static int B_1 = 30;
  private static int B_2 = 31;
  private static int C_2 = 32;
  private static int C_3 = 33;
  private static int D_1 = 34;
  private static int D_2 = 35;
  private static int E_1 = 36;
  private static int E_2 = 37;
  private static int E_3 = 38;
  private static int F_1 = 39;
  private static int F_2 = 40;
  private static int F_3 = 41;
  private static int F_4 = 42;
  private static int I42_1 = 43;
  private static int I42_2 = 44;
  private static int I42_3 = 45;
  private static int I42_4 = 46;
  private static int OFFROAD_1 = 47;            // Our new road!! :)

  private void initIntersections() {
    //		if( Global.DEBUG) {
    //		 	Global.debug.println("Initialize intersections");
    //			Global.debug.flush();
    //		}
    int[]  a1 = {I42_1};
    int[]  a2 = {First_1};
    int[]  a3 = {First_1, First_2, A_1};
    int[]  a4 = {First_2, First_3, B_1};
    int[]  a5 = {First_3, I42_1, First_4, I42_2};
    int[]  a6 = {First_4, First_5, D_1};
    int[]  a7 = {First_5, First_6, E_1};
    int[]  a8 = {First_6, First_7, F_1};
    int[]  a9 = {First_7};
    int[] a10 = {Second_1};
    int[] a11 = {Second_1, A_1, Second_2, A_2};
    int[] a12 = {Second_2, B_1, Second_3, B_2};
    int[] a13 = {Second_3, Second_4, C_2};
    int[] a14 = {Second_4, D_1, Second_5, D_2};
    int[] a15 = {Second_5, E_1, Second_6, E_2};
    int[] a16 = {Second_6, F_1, Second_7, F_2};
    int[] a17 = {Second_7};
    int[] a18 = {Third_1};
    int[] a19 = {Third_1, A_2,  Third_2, A_3};
    int[] a20 = {Third_2, B_2,  Third_3};
    int[] a21 = {Third_3, C_2,  Third_4, C_3};
    int[] a22 = {Third_4, I42_2, Third_5, I42_3};
    int[] a23 = {Third_5, D_2,  Third_6};
//    int[] a24 = {Third_6, E_2,  Third_7, E_3};
    int[] a24 = {Third_6, E_2,  Third_7, E_3, OFFROAD_1};                   //Changed for our new road
    int[] a25 = {Third_7, F_2,  Third_8, F_3};
    int[] a26 = {Third_8};
    int[] a27 = {Fourth_1};
    int[] a28 = {Fourth_1, A_3, Fourth_2};
//    int[] a29 = {Fourth_2, C_3, Fourth_3};
    int[] a29 = {Fourth_2, C_3, DirtRoad_1, OFFROAD_1};                     //Changed for our new road
//    int[] a30 = {Fourth_3, I42_3, E_3, Fourth_4, I42_4};
    int[] a30 = {DirtRoad_1, I42_3, E_3, Fourth_4, I42_4};
    int[] a31 = {Fourth_4, F_3, Fourth_5, F_4};
    int[] a32 = {Fourth_5};
    int[] a33 = {F_4};
    int[] a34 = {I42_4};

    int[]  s3 = {A_1};
    int[] s10 = {Second_1};
    int[] s12 = {Second_2};
    int[] s19 = {A_2};

    int[]  n1 = {0};
    int[]  n2 = {1};
    int[]  n3 = {0, 1, 1};
    int[]  n4 = {0, 0, 1, 1};
    int[]  n5 = {0, 0, 1};
    int[]  n6 = {0, 0, 0, 1, 1};
    int[]  n7 = {0, 0, 1, 1, 0};                                           //New directional vector for our new road

    Global.intersections = new TravQueue();
    if( LargeModel ) {
//      Global.intersections.enqueue(new Intersection(  a1, n2, new Coord(-37, -16)));
      Global.intersections.enqueue(new HighwayIntersection(  a1, n2, new Coord(-37, -16)));
      Global.intersections.enqueue(new Intersection(  a2, n2, new Coord(-44,   0)));
      Global.intersections.enqueue(new Stoplight(  a3, n3, new Coord(-32,   0)));
      Global.intersections.enqueue(new Stoplight(  a4, n3, new Coord(-22,   0)));
//      Global.intersections.enqueue(new Intersection(  a5, n4, new Coord(-13,   0)));
      Global.intersections.enqueue(new HighwayIntersection(  a5, n4, new Coord(-13,   0)));
      Global.intersections.enqueue(new Stoplight(  a6, n3, new Coord(  8,   0)));
      Global.intersections.enqueue(new Stoplight(  a7, n3, new Coord( 20,   0)));
      Global.intersections.enqueue(new Stoplight(  a8, n3, new Coord( 36,   0)));
      Global.intersections.enqueue(new Intersection(  a9, n1, new Coord( 46,   0)));
      Global.intersections.enqueue(new Intersection( a10, n2, new Coord(-44,   7)));
//      Global.intersections.enqueue(new Intersection( a11, n4, new Coord(-32,   7)));
      Global.intersections.enqueue(new Earthq( a11, n4, new Coord(-32,   7)));
      Global.intersections.enqueue(new Stoplight( a12, n4, new Coord(-22,   7)));
      Global.intersections.enqueue(new Intersection( a13, n3, new Coord(-13,   7)));
      Global.intersections.enqueue(new Stoplight( a14, n4, new Coord(  8,   7)));
      Global.intersections.enqueue(new Stoplight( a15, n4, new Coord( 20,   7)));
      Global.intersections.enqueue(new Stoplight( a16, n4, new Coord( 36,   7)));
      Global.intersections.enqueue(new Intersection( a17, n1, new Coord( 46,   7)));
      Global.intersections.enqueue(new Intersection( a18, n2, new Coord(-44,  16)));
      Global.intersections.enqueue(new Intersection( a19, n4, new Coord(-32,  16)));
      Global.intersections.enqueue(new Intersection( a20, n5, new Coord(-22,  16)));
      Global.intersections.enqueue(new Intersection( a21, n4, new Coord(-13,  16)));
//      Global.intersections.enqueue(new Intersection( a22, n4, new Coord(  0,  16)));
      Global.intersections.enqueue(new HighwayIntersection( a22, n4, new Coord(  0,  16)));
      Global.intersections.enqueue(new Intersection( a23, n5, new Coord(  8,  16)));
//      Global.intersections.enqueue(new Intersection( a24, n4, new Coord( 20,  16)));
      Global.intersections.enqueue(new Intersection( a24, n7, new Coord( 20,  16)));
      Global.intersections.enqueue(new Intersection( a25, n4, new Coord( 36,  16)));
      Global.intersections.enqueue(new Intersection( a26, n1, new Coord( 46,  16)));
      Global.intersections.enqueue(new Intersection( a27, n2, new Coord(-44,  26)));
      Global.intersections.enqueue(new Intersection( a28, n5, new Coord(-32,  26)));
      Global.intersections.enqueue(new Intersection( a29, n4, new Coord(-13,  26)));
//      Global.intersections.enqueue(new Intersection( a29, n5, new Coord(-13,  26)));
//      Global.intersections.enqueue(new Intersection( a30, n6, new Coord( 20,  26)));
      Global.intersections.enqueue(new HighwayIntersection( a30, n6, new Coord( 20,  26)));
      Global.intersections.enqueue(new Intersection( a31, n4, new Coord( 36,  26)));
      Global.intersections.enqueue(new Intersection( a32, n1, new Coord( 46,  26)));
      Global.intersections.enqueue(new Intersection( a33, n1, new Coord( 34,  36)));
//      Global.intersections.enqueue(new Intersection( a34, n1, new Coord( 46,  33)));
      Global.intersections.enqueue(new HighwayIntersection( a34, n1, new Coord( 46,  33)));
    } else {
      Global.intersections.enqueue(new Intersection(  s3, n2, new Coord(-32,   0)));
      Global.intersections.enqueue(new Intersection( s10, n2, new Coord(-44,   7)));
      Global.intersections.enqueue(new Intersection(  a11, n4, new Coord(-32,   7)));
      Global.intersections.enqueue(new Intersection( s12, n1, new Coord(-22,   7)));
      Global.intersections.enqueue(new Intersection( s19, n1, new Coord(-32,  16)));
    }
  }



  private void initStreets() {
    Global.streets = new StreetList();
    Global.streets.enqueue(new Street( "Second Ave 1", 35) );
    Global.streets.enqueue(new Street( "Second Ave 2", 35) );
    Global.streets.enqueue(new Street( "A St 1", 35) );
    Global.streets.enqueue(new Street( "A St 2", 35) );

    if( LargeModel ) {
      Global.streets.enqueue(new Street( "First Ave 1", 35) );
      Global.streets.enqueue(new Street( "First Ave 2", 35) );
      Global.streets.enqueue(new Street( "First Ave 3", 35) );
      Global.streets.enqueue(new Street( "First Ave 4", 35) );
      Global.streets.enqueue(new Street( "First Ave 5", 35) );
      Global.streets.enqueue(new Street( "First Ave 6", 35) );
      Global.streets.enqueue(new Street( "First Ave 7", 35) );
      Global.streets.enqueue(new Street( "Second Ave 3", 35) );
      Global.streets.enqueue(new Street( "Second Ave 4", 35) );
      Global.streets.enqueue(new Street( "Second Ave 5", 35) );
      Global.streets.enqueue(new Street( "Second Ave 6", 35) );
      Global.streets.enqueue(new Street( "Second Ave 7", 35) );
      Global.streets.enqueue(new Street( "Third Ave 1", 35) );
      Global.streets.enqueue(new Street( "Third Ave 2", 35) );
      Global.streets.enqueue(new Street( "Third Ave 3", 35) );
//      Global.streets.enqueue(new Street( "Third Ave 4", 35) );
//      Global.streets.enqueue(new Street( "Third Ave 5", 35) );
      Global.streets.enqueue(new Sidewalk( "Third Ave 4", 35) );            //altered to become sidewalks
      Global.streets.enqueue(new Sidewalk( "Third Ave 5", 35) );          ////////////////////////////////
      Global.streets.enqueue(new Street( "Third Ave 6", 35) );
      Global.streets.enqueue(new Street( "Third Ave 7", 35) );
      Global.streets.enqueue(new Street( "Third Ave 8", 35) );
      Global.streets.enqueue(new Street( "Fourth Ave 1", 35) );
      Global.streets.enqueue(new Street( "Fourth Ave 2", 35) );
      Global.streets.enqueue(new DirtRoad( "Dirt Road", 35) );                        //Our new road
//      Global.streets.enqueue(new Street( "Fourth Ave 3", 35) );
      Global.streets.enqueue(new Street( "Fourth Ave 4", 35) );
      Global.streets.enqueue(new Street( "Fourth Ave 5", 35) );
      Global.streets.enqueue(new Street( "A St 3", 35) );
      Global.streets.enqueue(new Street( "B St 1", 35) );
      Global.streets.enqueue(new Street( "B St 2", 35) );
      Global.streets.enqueue(new Street( "C St 1", 35) );
      Global.streets.enqueue(new Street( "C St 2", 35) );
      Global.streets.enqueue(new Street( "D St 1", 35) );
      Global.streets.enqueue(new Street( "D St 2", 35) );
      Global.streets.enqueue(new Street( "E St 1", 35) );
      Global.streets.enqueue(new OneWay( "E St 2", 35) );
      Global.streets.enqueue(new Street( "E St 3", 35) );
      Global.streets.enqueue(new Street( "F St 1", 35) );
      Global.streets.enqueue(new Street( "F St 2", 35) );
      Global.streets.enqueue(new Street( "F St 3", 35) );
      Global.streets.enqueue(new Street( "F St 4", 35) );
      Global.streets.enqueue(new Highway( "I42 1", 95) );
      Global.streets.enqueue(new Highway( "I42 2", 95) );
      Global.streets.enqueue(new Highway( "I42 3", 95) );
      Global.streets.enqueue(new Highway( "I42 4", 95) );
      Global.streets.enqueue(new DirtRoad( "OFFROAD 1", 50) );                        // Our new road = OFFROAD
//      Global.streets.enqueue(new Street( "I42 1", 65) );
//      Global.streets.enqueue(new Street( "I42 2", 65) );
//      Global.streets.enqueue(new Street( "I42 3", 65) );
//      Global.streets.enqueue(new Street( "I42 4", 65) );
    }
  }

  public static int [] feeders = {
    First_1,     // East
    First_7,     // West
    Second_1,    // East
    Second_7,    // West
    Third_1,     // East
    Third_8,     // West
    Fourth_1,    // East
    Fourth_5,    // West
    I42_1,       // South
    I42_4,       // North
    F_4          // North
  };

  public static int [] directions = {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1};

  public static int [] sfeeders = {
    Second_1,    // East
    Second_2,    // West
    A_1,    // South
    A_2     // North
  };

  public static int [] sdirections = {0, 1, 0, 1};
  /**
   * add vehicles to the streets
   */
  public static void addVehicles() {
    int i;

    if( LargeModel ) {
      for( i = 0; i < feeders.length; i++ ) { 
	Global.streets.insertVehicles( feeders[i], directions[i] );
      }
    } else {
      for( i = 0; i < sfeeders.length; i++ ) { 
	Global.streets.insertVehicles( sfeeders[i], sdirections[i] );
      }
    }
  }
}



