/**
 * A class simulating a Police Car on the chase
 * @author ELLIS MOSER and DAVID HARMAN
 *  Collaboration:
 *  David Harman:  The graphics of the Car
 *  Ellis Moser:  The chase code and the getaway car
 */
 
import java.awt.*;
import java.lang.*;

public class PoliceCar extends Vehicle {

  double trunk;
    int j=0;
    boolean light;

  /**
   * Construct a new car
   * @param mk the make of the car
   * @param md the model of the car
   * @param l its length in feet
   * @param tr its trunk capacity in cubic feet
   * @param x its x location (map coordinates)
   * @param y its y location (map coordinates)
   */
  public PoliceCar( String mk, String md, int l, double tr, int x, int y ) {

    super( mk, md, l, new Point(x, y) );
    trunk = tr;
    super.smartLevel=2;
    super.heading = Global.targetloc;
    super.destination = Global.targetloc;
	 System.out.println("Police2");
    }
    
  /**
 * update method moving the Police Car
 * @param distance the distance in map coordinates
 */
 	public void update(double distance) {
		super.update( distance * 1.25);
	}


  /**
   * draw a Police Car
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
  super.destination = Global.targetloc;
  
    Coord back = where.diff( heading.scale(0.75*length) ).screenScale();
    Coord front = where.screenScale();
    j++;
    if (j%5==0) light = !light;
    if (light) {
    g.setColor(Color.red);
    g.fillRect( (int) front.x, (int) front.y, 
		4,4);
		
    if(super.destination != null) {
      back = super.destination.screenScale();
      g.setColor(Color.blue);
      g.drawLine( (int) front.x, (int) front.y, 
		  (int) back.x, (int) back.y );
      back = back.diff(new Coord(5,5));
      g.drawOval( (int) back.x, (int) back.y, 10, 10);
      }
      }
      
      else {
		g.setColor(Color.blue);
		g.fillRect( (int) front.x, (int) front.y, 4,4);
		
		if(super.destination != null) {
      back = super.destination.screenScale();
      g.setColor(Color.red);
      g.drawLine( (int) front.x, (int) front.y, 
		  (int) back.x, (int) back.y );
      back = back.diff(new Coord(5,5));
    
      g.drawOval( (int) back.x, (int) back.y, 10, 10);
      }}
      
      
    
     if ((Math.abs(super.destination.distance(where)))<4)
        {
        Global.alive=false;
        }     
    }
  
  public void turn(Intersection here, Street strt, int dir)
  {
       if(Global.alive)
       { 
       int choice;
    int which;
       double best = 1000;
      double angleToDest = where.angleTo(super.destination);
      Street trySt;
      int tryDir;
      Coord otherEnd;
      double angleToTry;
      double diff;
      for( choice = 0; choice < here.streetIndex.length; choice++ ) {
	  which = here.streetIndex[choice];
	  trySt = (Street) Global.streets.find(which);
	  tryDir = 1 - here.directionIndex[choice];
	  otherEnd = trySt.location[tryDir];
	  angleToTry = where.angleTo(otherEnd);
	  diff = Math.abs( angleToDest - angleToTry );
	  if( diff > Math.PI ) diff = 2*Math.PI - diff;
	  if(Global.DEBUG)
	     Global.debug.println("try " + trySt
			       + "; direction " + tryDir
			       + "; other end is " + otherEnd
			       + "; angle to try " + angleToTry );
	  if( best > diff ) {
	    best = diff;
	    nextStreet = trySt;
	    nextDir = tryDir;
	    if(Global.DEBUG) Global.debug.println("adopted; best is " + best);
	  }
    
       }
       }else
         { super.nextStreet=null;
           super.destination=null;
           Global.chaseState=0;
           System.out.println(Global.chaseState);
         }
  }
  
  public String toString() {
    return "Getaway Car " + super.toString();
  }
}
