/**
 * A class providing basic queue functionality
 * @author David M. Smith
 */
 
import java.lang.*;

public class Queue {

  protected ListNode head;
  private ListNode tail;

  /**
   * Construct a new queue 
   */
  public Queue() {
    tail = null;
    head = null;
  }
	
  /**
   * add an object to the queue 
   * @param d the object to add
   */
  public void enqueue( Object d ) { 
    ListNode n = new ListNode( d, null );
    if( tail == null ) {
      head = n;
      tail = head;
    } else {
      tail.next = n;
      tail = n;
    }
  };

  /**
   * clear the queue
   * @return void
   */
   
   public void clearQueue(){
     Object worthless;
     while( head != null ){
       worthless = dequeue();
     }
  }
  
  /**
   * remove the first item 
   * @return the first object on the queue
   * @exception underflow if no data there
   */
  public Object dequeue(){
    if(isEmpty()) 
      throw new RuntimeException("Queue dequeue underflow");
    Object res = head.data;
    head = head.next;
    if( head == null ) tail = null;
    return res;
  };

  /**
   * look at the first item without removing it
   * @return the first object on the queue
   * @exception underflow if no data there
   */
  public Object peek() {
    if(isEmpty()) 
      throw new RuntimeException("Queue peek underflow");
    return head.data;
  };

  /**
   * determine if the stack is empty
   * @return true if empty, otherwise false
   */
  public boolean isEmpty(){
    return head == null;
  }


  /**
   * document the contents of the queue
   * @return the string describing the node
   */
  public String toString() {
    String res = "Queue:\n";
    ListNode here = head;

    while ( here != null ) {
      res = res + here.data.toString() + "\n";
      here = here.next;
    }
    return res;
  }

  public static void main(String[] args) {
    Queue q = new Queue();
    Object element = "";

    System.out.println("Empty queue is " + q);
    q.enqueue(new Integer(1));
    System.out.println("With 1 on it: " + q);
    q.enqueue(new Integer(2));
    System.out.println("With 1 and 2 on it: " + q);
    System.out.println("dequeue-> " + q.dequeue());
    System.out.println("After the dequeue: " + q);
    q.enqueue(new Integer(3));
    q.enqueue(new Integer(4));
    q.enqueue(new Integer(5));
    q.enqueue(new Integer(6));
    q.enqueue(new Integer(7));
    int i = 0;
    do {
      element = q.dequeue();
      System.out.println("Item " + i++ +
			 ": " + element + "\n");
    } while (!q.isEmpty());
  }
}


