/**
 * A class simulating a Semi
 * @author David M. Smith
 */
 
import java.awt.*;

public class Semi extends Vehicle {

  private double length1;
  private Coord lastBack;
  private boolean setBack;

   
  public Semi( String mk, String md, int l, int l1, int cars, int x, int y ) {

    super( mk, md, l, new Point(x, y), 1 );
    length1 = Global.SIZE_SCALE * l1 / Global.SCALE;
    setBack = false;
  }	
	 
	
  /**
   * draw a Semi
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
	
    Coord back = where.diff( heading.scale(0.75*length) );
    Coord dir = lastBack.diff(back).normalize();
    Coord tback = back.sum(dir.scale(length1*0.6));
    Coord whereS = where.screenScale();
    Coord backS = back.screenScale();
    Coord tbackS = tback.screenScale();
    /*
    Global.debug.println("Semi ID: " + ID + "; where  = " + where);
    Global.debug.println(" - trailer length  = " + length1);
    Global.debug.println(" - back of cab  = " + back);
    Global.debug.println(" - last back of trailer  = " + lastBack);
    Global.debug.println(" - direction to back of trailer  = " + dir);
    Global.debug.println(" - back of trailer  = " + tback);
    */
    g.setColor(Color.black );
    g.drawLine( (int) whereS.x, (int) whereS.y, 
		(int) backS.x, (int) backS.y );

    g.setColor( Color.red );
    g.drawLine( (int) backS.x, (int) backS.y, 
		(int) tbackS.x, (int) tbackS.y );
    lastBack = tback;
  }
	
  public void locate( Coord p, Coord h) {
    super.locate(p, h);
    if( !setBack ) {
      setBack = true;
      lastBack = where.diff( h.scale(length1) );
    }
  }


public Coord shuffle(Coord back, double speed, Coord dir) {
    Coord cabBack = super.shuffle( back, speed, dir );
    Coord newBack = cabBack.sum( dir.scale(length1) );
    if( Global.DEBUG ) {
      Global.debug.println( "; trailer back is now " + newBack );
    }
    return newBack;
  }

  public String toString() {
    return "Semi " + super.toString();
  }
}
