/**
 *Frank Fearon J_4
 */

import java.awt.*;
import java.lang.*;

public class Sidewalk extends Street {

  int count;
  /**
   * Construct a new sidewalk
   */
  public Sidewalk(String nm, int lim ) {

   super( nm, lim);
	width = (Global.STREET_WIDTH)/3;
	count = 0;
	System.out.println("Sidewalk");
  }

  public void update(double dt) {

  	driving[1].update(dt * limit);
  	Pedestrian P = null;
  	count++;
  	if( (count < 500) && (count%50 == 0)) {
      P = new Pedestrian("Man", "1982", 9, 20, 20 );
		driving[1].enqueue(P);
  	}
  }
  /**
   * draw the street
   * @param g the graphics environment
   */
    public void draw(Graphics g) {

      Coord from = location[0].screenScale();
      Coord   to = location[1].screenScale();
      double size = from.distance(to);
      Coord unit_normal = from.perp( to, size );
      int i;

      Coord leftFrom  =  from.sum( unit_normal.scale(width) );
      Coord leftTo    =    to.sum( unit_normal.scale(width) );
      Coord rightFrom = from.diff( unit_normal.scale(width) );
      Coord rightTo   =   to.diff( unit_normal.scale(width) );
      g.setColor(Color.white);
      g.drawLine( (int)  leftFrom.x, (int)  leftFrom.y,
  		(int)  leftTo.x, (int)  leftTo.y );
      g.drawLine( (int) rightFrom.x, (int) rightFrom.y,
  		(int) rightTo.x, (int) rightTo.y );
      driving[1].draw(g);
    }

public boolean isFull( int d, Vehicle v) {
	 boolean answer = true;
	 return answer;
}

public boolean isEmpty( int d ) {
	return super.isEmpty(d);
}

public Vehicle dequeue( int d ) {
	return super.dequeue(d);
}


public Vehicle peek( int d ) {
	return super.peek(d);
}

public void enqueue( Vehicle v, int d) {


	if (v.getLength() < 10){  //keeps vehicles off the sidewalks

	Coord delta = direction[d].normal().scale( width/(2*Global.SCALE) );

	    driving[d].enqueue(v);
	    v.locate( location[1-d].diff(delta), direction[d] );
	    v.update( v.getLength() + Global.STREET_WIDTH/Global.SCALE );

    }
}


}