/**
 * A class simulating a motorcycle
 * @author Daniel Sellers
 */
 
import java.awt.*;

public class StallCar extends Vehicle {

protected int count=200;
protected int stall=500;


    /**
     * Construct a new StallCar
     * @param mk the make of the StallCar
     * @param md the model of the StallCar
     * @param l its length in feet
     * @param x its x location (map coordinates)
     * @param y its y location (map coordinates)
     */
    public StallCar( String mk, String md, int l, double tr, int x, int y ) {

        super( mk, md, l, new Point(x, y) );
		  System.out.println("Stalled car");
	}


/**
 * update method moving the StallCar
 * @param distance the distance in map coordinates
 */
 	public void update(double distance) {
 
 	    if ( Global.isstall==true && stall >0){
                stall-- ;
          } else {
                super.update( distance );
             }
                if (stall == 0){
	                Global.isstall=false;
						 System.out.println("Stalled car started");
	                stall = 500;
	            }
	}



	/**
	 * draw a StallCar
	 * @param g the graphics environment
	 */
	 public void draw(Graphics g) {
	    if ( Global.isstall==true && count > 0){
	        Coord back = where.diff( heading.scale(0.75*length) ).screenScale();
            Coord front = where.screenScale();
            g.setColor(Color.red);
	        count-- ;
	        g.drawOval((int) (back.x - 50),(int) (back.y - 50) ,100,100);
	        
	        }
	 	super.draw(g, Color.black );
	 }
  
    /**
     * display the StallCar
     */
	  public String toString() {
			return "StallCar " + super.toString();
	  }
}
