/**
 * A class providing a stoplight funciton at the intersection
 * @author Brandon Reed
            Brandon Saadiq
            Anna Buseman-Williams
 * Dr. Smith-  We worked for hours attempting to make our code do something to the traffic model. However to our dismay, nothing
 * happened, but we really made an effort, and we consulted the ta's. We are sorry. 
 */
 
import java.awt.*;
import java.lang.*;

	public class Stoplight extends Intersection {
		private boolean runOdds;
		private int count;
   /**
   * Construct a new Stoplight
   */ 
	public Stoplight (int[] stIndex, int[] dirIndex, Coord p ){
		super(stIndex, dirIndex, p);
		System.out.println("Stop light");
		runOdds = false;
		count = (int) (200 * Math.random());
	}

	/**
   * draw the intersection
   * @param g the graphics environment
   */
  public void draw(Graphics g) {
    Coord here = position.screenScale();
  	super.draw(g);
	count++;
	runOdds = ((count % 200) < 100);
    g.setColor(Color.red);
	 if( runOdds ) {
		g.drawLine( (int) (here.x - 2*Global.STREET_WIDTH), (int) here.y,
	 			 		(int) (here.x + 2*Global.STREET_WIDTH), (int) here.y );
	 } else {
		g.drawLine( (int) here.x, (int) (here.y - 2*Global.STREET_WIDTH),
	 			 		(int) here.x, (int) (here.y + 2*Global.STREET_WIDTH));
	 }
  }

  public void update(double x) {

    int index;
    Street strt;
    int direction;
    Street outStreet;
    int outDir;
    int i;
    int which;
    int choice;
    Vehicle v;
	 boolean canGo;
    /*
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;;
      ;;  this is the basic free flowing traffic control logic
      ;;  it works fine as-is.  For other flow control methods,
      ;;  derive a child class from this and change the logic accordingly
      ;; 
      ;;  4 way stop might cycle through the streets, taking only the 
      ;;    first available car from one street
      ;;
      ;;  traffic lights might permit cars from odd or even indexed streets 
      ;;    switching to the other state after some period of time
    */
    for( i = 0; i < streetIndex.length; i++ ) {
      index = streetIndex[i];
      strt = (Street) Global.streets.find(index);
      direction = directionIndex[i];
		canGo = !strt.isEmpty(direction);
		if( runOdds ) {
			if( (direction%2) == 0 ) canGo = false;
		} else {
			if( (direction%2) > 0 ) canGo = false;
		}
      if( canGo )  {
			v = strt.peek(direction);
			// pick the outgoing street
			v.turn(this, strt, direction);
			outStreet = v.getNextStreet();
			outDir = v.getNextDirection();
			if( outStreet == null ) {
	  			strt.dequeue(direction);
			} else {
	  			if( !outStreet.isFull(outDir, v) ) {
	    			try {
	      			outStreet.enqueue( strt.dequeue(direction), outDir );
	    			} catch( Exception e) { 
	      			System.out.print("Error " + e + " dequeuing" ); 
	      			Global.debug.println("Error " + e + " dequeuing" );
	    			} 
	  			}
			}
      }
    }
  }
}
