/**
 * A class simulating a Sunday Driver (The Drivers that drive at half the speed limit with no particular place to go, just driving to see what they can see) 
 * @author Amber Bethune and Corey Wood
 *      Collaboration Statement
 *        The following students contributed to this project:
 *          Amber Bethune gte926z - Idea of Sunday Drivers, Half of Coding
 *          Corey Wood gtg249b - Other Half of Coding
 */
 
import java.awt.*;

public class Sunday extends Vehicle {

    /**
     * Construct a new Sunday driver
     * @param mk the make of the Sunday driver
     * @param md the model of the Sunday driver
     * @param l its length in feet
     * @param x its x location (map coordinates)
     * @param y its y location (map coordinates)
     */
	public Sunday( String mk, String md, int l, int x, int y ) {

		super( mk, md, l, new Point(x, y) );
		System.out.println("Sunday");
	}


/**
 * update method to slow the speed of the Sunday driver
 * @param distance the distance in map coordinates
 */
 	public void update(double distance) {
		super.update(distance * .3);
	}



	/**
	 * draw a Sunday Driver
	 * @param g the graphics environment
	 */
	 public void draw(Graphics g) {
	 	super.draw(g, Color.white );
	 }

    /**
     * display the Sunday driver
     */
	  public String toString() {
			return "Sunday Driver " + super.toString();
	  }
}
