/**
 * A class simulating a car transporter
 * @author David M. Smith
 */
 
import java.awt.*;

public class Transporter extends Vehicle {

	private TravQueue carQ;

    /**
     * Construct a new transporter
     * @param mk the make of the transporter
     * @param md the model of the transporter
     * @param l its length in feet
     * @param cars number of cars it is carrying
     * @param x its x location (map coordinates)
     * @param y its y location (map coordinates)
     */
	public Transporter( String mk, String md, int l, int cars, int x, int y ) {

		super( mk, md, l, new Point(x, y), 1 );
	}

/**
 * update method moving the transporter
 * @param distance the distance in map coordinates
 */
 	public void update(double distance) {
		super.update( distance / 2.);
	}

	/**
	 * draw a Transporter
	 * @param g the graphics environment
	 */
	 public void draw(Graphics g) {
	 	super.draw(g, Color.black );
	 }



    /**
     * display the transporter
     */
	  public String toString() {
			return "Transporter " + super.toString();
	  }
}
